/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 33 "./ctp_y.y" /* yacc.c:339  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "aut.h"
#include "vex.h"
#include "ctl.h"

#include "ctp_utype.h"
#include "ctp_bedef.h"
#include "ctp_bspec.h"
#include "ctp_byacc.h"

#if 1
# define my_fprintf fprintf( stdout, "%s.%d:", autbasename(__FILE__,NULL), __LINE__ ); fprintf
# define my_ctp_error(N,V) \
   do { fprintf( stderr, "%s.%d:", autbasename(__FILE__,NULL), __LINE__); ctp_error(N,V); } while(0)
#else
# define my_fprintf   fprintf
# define my_ctp_error ctp_error
#endif

#ifdef CTP_DEBUG
#define YYDEBUG 1
#endif


#line 95 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    _AF = 258,
    _AG = 259,
    _AX = 260,
    _AU = 261,
    _EF = 262,
    _EG = 263,
    _EX = 264,
    _EU = 265,
    Imply = 266,
    Equiv = 267,
    tok_AND = 268,
    _BEGIN = 269,
    _END = 270,
    _EQSym = 271,
    _EXIT = 272,
    _FILE = 273,
    _GESym = 274,
    _GTSym = 275,
    _IN = 276,
    _INOUT = 277,
    _LABEL = 278,
    _LESym = 279,
    _LINKAGE = 280,
    _LTSym = 281,
    _NAND = 282,
    _IFT = 283,
    _NXOR = 284,
    _NESym = 285,
    _NEXT = 286,
    _NOR = 287,
    _NOT = 288,
    _OR = 289,
    _OUT = 290,
    _XOR = 291,
    ABS = 292,
    ACCESS = 293,
    AFTER = 294,
    ALIAS = 295,
    ALL = 296,
    ARCHITECTURE = 297,
    ARRAY = 298,
    ASSERT = 299,
    ATTRIBUTE = 300,
    AbstractLit = 301,
    Ampersand = 302,
    Apostrophe = 303,
    Arrow = 304,
    BLOCK = 305,
    BODY = 306,
    BUS = 307,
    _BUFFER = 308,
    Bar = 309,
    BasedInt = 310,
    BasedReal = 311,
    BitStringLit = 312,
    _TRUE = 313,
    _FALSE = 314,
    Box = 315,
    CASE = 316,
    COMPONENT = 317,
    CONFIGURATION = 318,
    _DEFINE = 319,
    _ASSUME = 320,
    _INITIAL = 321,
    _RESET_COND = 322,
    CharacterLit = 323,
    Colon = 324,
    Comma = 325,
    DISCONNECT = 326,
    DOWNTO = 327,
    DecimalInt = 328,
    DecimalReal = 329,
    Dot = 330,
    DoubleStar = 331,
    ELSE = 332,
    ELSIF = 333,
    _ENTITY = 334,
    ERROR = 335,
    _EVENT = 336,
    _LEFT = 337,
    _LENGTH = 338,
    _RIGHT = 339,
    _HIGH = 340,
    _LOW = 341,
    FOR = 342,
    FUNCTION = 343,
    GENERATE = 344,
    GENERIC = 345,
    GUARDED = 346,
    IF = 347,
    IS = 348,
    _NS = 349,
    _PS = 350,
    _FS = 351,
    _MS = 352,
    Identifier = 353,
    _LIBRARY = 354,
    LOOP = 355,
    LeftParen = 356,
    MAP = 357,
    MOD = 358,
    Minus = 359,
    NEW = 360,
    OF = 361,
    ON = 362,
    OPEN = 363,
    OTHERS = 364,
    _PACKAGE = 365,
    PORT = 366,
    PROCEDURE = 367,
    PROCESS = 368,
    Plus = 369,
    _RANGE = 370,
    _REV_RANGE = 371,
    RECORD = 372,
    REGISTER = 373,
    REM = 374,
    REPORT = 375,
    _RETURN = 376,
    RightParen = 377,
    SELECT = 378,
    SEVERITY = 379,
    SIGNAL = 380,
    _STABLE = 381,
    SUBTYPE = 382,
    Semicolon = 383,
    Slash = 384,
    Star = 385,
    StringLit = 386,
    THEN = 387,
    TO = 388,
    TRANSPORT = 389,
    _TYPE = 390,
    UNITS = 391,
    UNTIL = 392,
    USE = 393,
    _VARIABLE = 394,
    VarAsgn = 395,
    WAIT = 396,
    WARNING = 397,
    WHEN = 398,
    WHILE = 399,
    WITH = 400
  };
#endif
/* Tokens.  */
#define _AF 258
#define _AG 259
#define _AX 260
#define _AU 261
#define _EF 262
#define _EG 263
#define _EX 264
#define _EU 265
#define Imply 266
#define Equiv 267
#define tok_AND 268
#define _BEGIN 269
#define _END 270
#define _EQSym 271
#define _EXIT 272
#define _FILE 273
#define _GESym 274
#define _GTSym 275
#define _IN 276
#define _INOUT 277
#define _LABEL 278
#define _LESym 279
#define _LINKAGE 280
#define _LTSym 281
#define _NAND 282
#define _IFT 283
#define _NXOR 284
#define _NESym 285
#define _NEXT 286
#define _NOR 287
#define _NOT 288
#define _OR 289
#define _OUT 290
#define _XOR 291
#define ABS 292
#define ACCESS 293
#define AFTER 294
#define ALIAS 295
#define ALL 296
#define ARCHITECTURE 297
#define ARRAY 298
#define ASSERT 299
#define ATTRIBUTE 300
#define AbstractLit 301
#define Ampersand 302
#define Apostrophe 303
#define Arrow 304
#define BLOCK 305
#define BODY 306
#define BUS 307
#define _BUFFER 308
#define Bar 309
#define BasedInt 310
#define BasedReal 311
#define BitStringLit 312
#define _TRUE 313
#define _FALSE 314
#define Box 315
#define CASE 316
#define COMPONENT 317
#define CONFIGURATION 318
#define _DEFINE 319
#define _ASSUME 320
#define _INITIAL 321
#define _RESET_COND 322
#define CharacterLit 323
#define Colon 324
#define Comma 325
#define DISCONNECT 326
#define DOWNTO 327
#define DecimalInt 328
#define DecimalReal 329
#define Dot 330
#define DoubleStar 331
#define ELSE 332
#define ELSIF 333
#define _ENTITY 334
#define ERROR 335
#define _EVENT 336
#define _LEFT 337
#define _LENGTH 338
#define _RIGHT 339
#define _HIGH 340
#define _LOW 341
#define FOR 342
#define FUNCTION 343
#define GENERATE 344
#define GENERIC 345
#define GUARDED 346
#define IF 347
#define IS 348
#define _NS 349
#define _PS 350
#define _FS 351
#define _MS 352
#define Identifier 353
#define _LIBRARY 354
#define LOOP 355
#define LeftParen 356
#define MAP 357
#define MOD 358
#define Minus 359
#define NEW 360
#define OF 361
#define ON 362
#define OPEN 363
#define OTHERS 364
#define _PACKAGE 365
#define PORT 366
#define PROCEDURE 367
#define PROCESS 368
#define Plus 369
#define _RANGE 370
#define _REV_RANGE 371
#define RECORD 372
#define REGISTER 373
#define REM 374
#define REPORT 375
#define _RETURN 376
#define RightParen 377
#define SELECT 378
#define SEVERITY 379
#define SIGNAL 380
#define _STABLE 381
#define SUBTYPE 382
#define Semicolon 383
#define Slash 384
#define Star 385
#define StringLit 386
#define THEN 387
#define TO 388
#define TRANSPORT 389
#define _TYPE 390
#define UNITS 391
#define UNTIL 392
#define USE 393
#define _VARIABLE 394
#define VarAsgn 395
#define WAIT 396
#define WARNING 397
#define WHEN 398
#define WHILE 399
#define WITH 400

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 62 "./ctp_y.y" /* yacc.c:355  */

          long          valu;
          char         *text;
          chain_list   *pcha;
          ctp_name      name;
          ctp_vexstr    list;
          ctltype_list  type;
       

#line 435 "y.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 450 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   376

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  146
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  70
/* YYNRULES -- Number of rules.  */
#define YYNRULES  151
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  251

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   400

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   275,   275,   275,   316,   326,   329,   331,   336,   337,
     338,   339,   340,   341,   342,   343,   351,   419,   464,   509,
     555,   561,   640,   644,   667,   669,   671,   676,   698,   718,
     738,   744,   750,   807,   809,   816,   820,   827,   834,   839,
     895,   902,   904,   909,   916,   921,   928,   933,   942,   948,
     958,   995,   997,  1004,  1022,  1025,  1027,  1032,  1033,  1039,
    1062,  1064,  1066,  1068,  1073,  1079,  1088,  1094,  1103,  1105,
    1111,  1117,  1123,  1129,  1138,  1150,  1156,  1165,  1167,  1176,
    1181,  1183,  1195,  1204,  1206,  1208,  1212,  1214,  1219,  1221,
    1223,  1225,  1230,  1232,  1241,  1245,  1251,  1256,  1261,  1266,
    1271,  1276,  1281,  1286,  1294,  1304,  1331,  1424,  1440,  1487,
    1489,  1491,  1493,  1495,  1497,  1499,  1501,  1506,  1508,  1511,
    1513,  1515,  1517,  1522,  1538,  1541,  1555,  1564,  1578,  1595,
    1597,  1599,  1604,  1679,  1719,  1798,  1799,  1800,  1801,  1802,
    1803,  1804,  1805,  1806,  1811,  1810,  1815,  1817,  1826,  1831,
    1836,  1841
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "_AF", "_AG", "_AX", "_AU", "_EF", "_EG",
  "_EX", "_EU", "Imply", "Equiv", "tok_AND", "_BEGIN", "_END", "_EQSym",
  "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT", "_LABEL",
  "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_IFT", "_NXOR", "_NESym",
  "_NEXT", "_NOR", "_NOT", "_OR", "_OUT", "_XOR", "ABS", "ACCESS", "AFTER",
  "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT", "ATTRIBUTE",
  "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BLOCK", "BODY",
  "BUS", "_BUFFER", "Bar", "BasedInt", "BasedReal", "BitStringLit",
  "_TRUE", "_FALSE", "Box", "CASE", "COMPONENT", "CONFIGURATION",
  "_DEFINE", "_ASSUME", "_INITIAL", "_RESET_COND", "CharacterLit", "Colon",
  "Comma", "DISCONNECT", "DOWNTO", "DecimalInt", "DecimalReal", "Dot",
  "DoubleStar", "ELSE", "ELSIF", "_ENTITY", "ERROR", "_EVENT", "_LEFT",
  "_LENGTH", "_RIGHT", "_HIGH", "_LOW", "FOR", "FUNCTION", "GENERATE",
  "GENERIC", "GUARDED", "IF", "IS", "_NS", "_PS", "_FS", "_MS",
  "Identifier", "_LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "Minus",
  "NEW", "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE",
  "PROCESS", "Plus", "_RANGE", "_REV_RANGE", "RECORD", "REGISTER", "REM",
  "REPORT", "_RETURN", "RightParen", "SELECT", "SEVERITY", "SIGNAL",
  "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star", "StringLit", "THEN",
  "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "_VARIABLE",
  "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH", "$accept",
  "ctl_file", "$@1", "ctl_body", "ctl_declarative_part",
  "..block_declarative_item..", "block_declarative_item",
  "constant_declaration", "assumption_declaration", "initial_declaration",
  "reset_cond_declaration", "constant_VarAsgn__expression",
  "variable_declaration", "type_declaration", "full_type_declaration",
  "type_definition", "subtype_declaration", "subtype_indication",
  "type_or_function_name", "scalar_type_definition",
  "enumeration_type_definition", "...enumeration_literal..",
  "enumeration_literal", "composite_type_definition",
  "array_type_definition", "constrained_array_definition",
  "index_constraint", "discrete_range", ".constraint.", "constraint",
  "range_constraint", "range", "direction", "type_mark",
  "ctl_statement_part", "..concurrent_statement..", "concurrent_statement",
  "formula_assignment_statement", "expression",
  "relation..AND__relation..", "relation..OR__relation..",
  "relation.NAND_NOR_NXOR_relation.", "relation..XOR__relation..",
  "relation", "simple_expression", ".sign.term..add_op__term..",
  "adding_operator", "sign", "multiplying_operator", "term", "factor",
  "primary", "qualified_expression", "relational_operator", "literal",
  "aggregate", "...element_association..", "element_association", "name",
  "indexed_name", "slice_name", "attribute_name", "attribute_designator",
  "identifier_list", "$@2", "...identifier..", "simple_name",
  "RightParen_ERR", "Semicolon_ERR", "END_ERR", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400
};
# endif

#define YYPACT_NINF -99

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-99)))

#define YYTABLE_NINF -55

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -99,    21,   -99,   -99,   -99,    14,    15,   -99,   -98,   -57,
     -43,   -42,   -38,   -34,   -33,   -30,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,   -99,    44,     2,   -99,   -99,    -8,
     -71,   -71,   -71,   -22,    -7,   -99,    20,   -99,   -98,   -98,
     -99,   -99,   -99,    22,    -3,   118,   -98,   -98,   -98,    -3,
       7,   -99,    -3,   -99,   -99,   118,   -49,   -99,   110,   110,
     110,     3,   110,   110,   110,    10,   110,   110,   -99,   -99,
     -99,   -99,   -99,    39,   -99,   -99,   -99,   -99,   100,    81,
     -99,    82,   231,   287,   -20,   196,    62,   -99,    43,   -99,
     -99,   -99,    96,   -99,   -99,   -99,    37,   -99,   -99,   -99,
     -98,    -3,   -49,    51,   -98,    59,   -44,   -98,   -99,   -99,
     -99,   -99,   -99,    91,   -49,   -98,   126,   126,   -71,   -99,
     -99,   -99,   -99,   -99,   126,   -99,   -99,   -99,   126,   -99,
     -99,   103,   -99,   -99,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   126,   -99,   -99,   -99,   196,    62,   -99,   -99,
     -99,   -99,   196,   110,   207,    39,   -99,   -99,   -49,   -99,
     -99,   126,    60,   -99,   -99,   -99,   -99,    73,   -98,   -99,
      52,   -60,   -23,   -99,   -98,   112,   117,   118,   -45,   -99,
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
      62,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -99,   -99,   -99,    90,   -99,    52,   -99,   -99,   -28,
     -48,    -3,   -19,   -99,   -99,   -99,   -99,   -99,   -99,   126,
     -99,   126,   126,   -99,    39,   -99,   126,   -99,   -99,   -99,
     -44,   -99,   -99,    52,    52,   -99,    52,   -99,   -99,   -99,
     -99
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     6,     1,     3,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     8,    10,    11,
      12,     9,    13,    22,    14,     0,     0,   150,    15,     0,
       0,     0,     0,     0,     0,   144,     0,   151,     0,     0,
     148,    56,    57,     0,     0,     0,     0,     0,     0,     0,
       0,   146,     0,     4,    58,     0,    44,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,   120,
     121,   122,   118,     0,    87,    86,   119,    20,    60,    61,
      62,    63,    68,    77,    79,     0,    80,    92,    94,   107,
     104,   105,   106,   129,   130,   131,   128,    17,    18,    19,
       0,     0,    44,    53,     0,     0,     0,     0,    24,    31,
      25,    37,    38,   145,    44,     0,     0,     0,     0,    45,
      46,    99,    98,   100,     0,   101,   102,   103,     0,    97,
      96,     0,   126,   124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   116,   115,   109,   111,   112,   113,
     114,   110,     0,    85,    84,    83,     0,    81,    90,    91,
      89,    88,     0,     0,     0,     0,   132,    27,    44,    29,
      26,     0,     0,    36,    35,    33,    23,     0,     0,    59,
       0,     0,   131,    48,     0,     0,     0,     0,     0,    65,
      67,    76,    64,    69,    72,    71,    70,    66,    75,    78,
      82,    93,    95,   136,   137,   141,   138,   140,   139,   142,
     143,   135,   108,   134,    77,    28,     0,    41,    43,   106,
     128,     0,     0,   147,    21,   149,    47,    52,    51,     0,
      16,     0,     0,   127,     0,   123,     0,    40,    42,    39,
       0,    32,    50,     0,     0,   125,     0,    34,    74,    73,
     133
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,   -99,
     -99,   -25,   -99,   -99,   -99,   -99,   -99,   -32,   -99,   -99,
     -99,   -99,   -67,   -99,   -99,   -99,   -99,   -99,   -80,   -99,
     -31,   -79,   -24,   -39,   -99,   -99,   -99,   -99,   -41,   -99,
     -99,   -99,   -99,   144,    41,   -99,   -99,   -99,   -99,   -66,
      18,   -27,   -99,   -99,   -99,   -81,   -99,   -36,    25,   -99,
     -99,   -59,   -99,   -99,   -99,   -99,   -26,    -9,   -37,   -99
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     4,     5,     6,    16,    17,    18,    19,
      20,    46,    21,    22,    23,   107,    24,   100,   101,   108,
     109,   222,   175,   110,   111,   112,   172,   216,   118,   119,
     120,   180,   229,   102,    25,    26,    41,    42,   132,    78,
      79,    80,    81,    82,    83,    84,   156,    85,   162,    86,
      87,    88,    89,   152,    90,    91,   188,   133,    92,    93,
      94,    95,   213,    36,    51,   113,    96,   226,    28,    38
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,    53,    54,    39,    77,    56,    47,    48,   104,    97,
      98,    99,   227,   114,   115,   166,     8,   -54,    57,   157,
     164,     3,   169,   103,   173,   234,    57,   153,     7,    -5,
      27,   121,   122,   123,   178,   125,   126,   127,   183,   129,
     130,    29,    58,    59,    60,    61,    62,    63,    64,    65,
     105,   240,   116,   165,   174,    30,    31,   182,   182,    37,
      32,    44,   168,   167,    33,    34,   117,   170,    35,    45,
     176,    49,    66,   228,   -53,    57,    67,   225,   179,     9,
      10,    11,    12,   212,   154,    68,    50,   117,   215,    52,
     200,    55,   217,   184,   155,    40,    69,    70,    71,   -49,
      40,   144,   145,   225,   124,   -49,   146,    72,   106,   147,
     148,   128,   182,   134,   149,   135,   150,   -49,   136,   163,
     151,    58,    59,    60,    61,    62,    63,    64,    65,    58,
      59,    60,   218,    62,    63,    64,   202,    40,   165,   166,
      73,   224,    13,    74,   164,   220,   233,   230,   131,   -30,
      14,    66,   187,    75,    15,    67,    68,   181,   181,    66,
     171,   177,   227,    67,    68,   158,   221,    69,    70,    71,
      76,   223,    68,   247,   225,    69,    70,    71,    72,   235,
     201,   159,   231,    69,    70,    71,    72,   232,   238,   239,
     236,   160,   161,   199,    72,   103,   219,     0,   245,    58,
      59,    60,     0,    62,    63,    64,   214,   237,    40,     0,
       0,    73,   181,   241,     0,     0,    40,     0,     0,    73,
       0,     0,    74,   228,    40,     0,     0,    73,     0,    66,
      74,     0,    75,    67,   248,   249,     0,   250,     0,     0,
      75,    76,    68,     0,   137,     0,     0,     0,     0,    76,
       0,     0,     0,    69,    70,    71,     0,    76,   138,   139,
     140,     0,     0,   141,    72,   142,     0,   143,   185,     0,
     242,     0,   186,     0,     0,     0,     0,   246,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   203,   204,
     205,   206,   207,   208,    40,     0,     0,    73,   144,   145,
       0,     0,     0,   146,     0,     0,   147,   148,    73,     0,
       0,   149,     0,   150,     0,     0,     0,   151,     0,     0,
       0,     0,   209,   210,     0,     0,     0,    76,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244
};

static const yytype_int16 yycheck[] =
{
      26,    38,    39,     1,    45,    44,    31,    32,     1,    46,
      47,    48,    72,    52,    55,    96,     1,    15,    44,    85,
      48,     0,   102,    49,    68,    70,    52,    47,    14,    14,
     128,    58,    59,    60,   114,    62,    63,    64,   117,    66,
      67,    98,     3,     4,     5,     6,     7,     8,     9,    10,
      43,    70,   101,   101,    98,    98,    98,   116,   117,    15,
      98,    69,   101,   100,    98,    98,   115,   104,    98,   140,
     107,    93,    33,   133,   122,   101,    37,   122,   115,    64,
      65,    66,    67,   164,   104,    46,    93,   115,   168,    69,
     156,    69,   171,   118,   114,    98,    57,    58,    59,   122,
      98,    11,    12,   122,   101,   128,    16,    68,   101,    19,
      20,   101,   171,    13,    24,    34,    26,   140,    36,    76,
      30,     3,     4,     5,     6,     7,     8,     9,    10,     3,
       4,     5,   171,     7,     8,     9,   163,    98,   101,   220,
     101,   178,   127,   104,    48,   171,   187,   184,   109,    98,
     135,    33,    49,   114,   139,    37,    46,   116,   117,    33,
     101,    70,    72,    37,    46,   103,   106,    57,    58,    59,
     131,    98,    46,   240,   122,    57,    58,    59,    68,   188,
     162,   119,    70,    57,    58,    59,    68,    70,   219,   221,
     214,   129,   130,   152,    68,   221,   171,    -1,   234,     3,
       4,     5,    -1,     7,     8,     9,   165,   216,    98,    -1,
      -1,   101,   171,   222,    -1,    -1,    98,    -1,    -1,   101,
      -1,    -1,   104,   133,    98,    -1,    -1,   101,    -1,    33,
     104,    -1,   114,    37,   243,   244,    -1,   246,    -1,    -1,
     114,   131,    46,    -1,    13,    -1,    -1,    -1,    -1,   131,
      -1,    -1,    -1,    57,    58,    59,    -1,   131,    27,    28,
      29,    -1,    -1,    32,    68,    34,    -1,    36,   124,    -1,
     229,    -1,   128,    -1,    -1,    -1,    -1,   236,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,    81,    82,
      83,    84,    85,    86,    98,    -1,    -1,   101,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,   101,    -1,
      -1,    24,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,   115,   116,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,   232
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   147,   148,     0,   149,   150,   151,    14,     1,    64,
      65,    66,    67,   127,   135,   139,   152,   153,   154,   155,
     156,   158,   159,   160,   162,   180,   181,   128,   214,    98,
      98,    98,    98,    98,    98,    98,   209,    15,   215,     1,
      98,   182,   183,   212,    69,   140,   157,   157,   157,    93,
      93,   210,    69,   214,   214,    69,   179,   212,     3,     4,
       5,     6,     7,     8,     9,    10,    33,    37,    46,    57,
      58,    59,    68,   101,   104,   114,   131,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   195,   196,   197,   198,
     200,   201,   204,   205,   206,   207,   212,   214,   214,   214,
     163,   164,   179,   212,     1,    43,   101,   161,   165,   166,
     169,   170,   171,   211,   179,   184,   101,   115,   174,   175,
     176,   197,   197,   197,   101,   197,   197,   197,   101,   197,
     197,   109,   184,   203,    13,    34,    36,    13,    27,    28,
      29,    32,    34,    36,    11,    12,    16,    19,    20,    24,
      26,    30,   199,    47,   104,   114,   192,   195,   103,   119,
     129,   130,   194,    76,    48,   101,   201,   214,   179,   174,
     214,   101,   172,    68,    98,   168,   214,    70,   174,   214,
     177,   190,   207,   177,   157,   189,   189,    49,   202,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   190,
     195,   196,   197,    81,    82,    83,    84,    85,    86,   115,
     116,   126,   201,   208,   190,   174,   173,   177,   179,   204,
     212,   106,   167,    98,   214,   122,   213,    72,   133,   178,
     214,    70,    70,   184,    70,   213,   178,   213,   176,   163,
      70,   213,   190,   189,   189,   203,   190,   168,   213,   213,
     213
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   146,   148,   147,   149,   150,   151,   151,   152,   152,
     152,   152,   152,   152,   152,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   161,   161,   162,   163,   163,
     164,   165,   166,   167,   167,   168,   168,   169,   170,   171,
     172,   173,   173,   173,   174,   174,   175,   175,   176,   177,
     177,   178,   178,   179,   180,   181,   181,   182,   182,   183,
     184,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   188,   188,   189,   189,   190,
     191,   191,   191,   192,   192,   192,   193,   193,   194,   194,
     194,   194,   195,   195,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   197,   197,   197,   197,   198,   199,
     199,   199,   199,   199,   199,   199,   199,   200,   200,   200,
     200,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     204,   204,   205,   206,   207,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   210,   209,   211,   211,   212,   213,
     214,   215
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     5,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     7,     4,     4,     4,
       2,     6,     1,     5,     1,     1,     2,     5,     3,     2,
       1,     1,     4,     0,     3,     1,     1,     1,     1,     4,
       3,     1,     2,     1,     0,     1,     1,     3,     2,     1,
       3,     1,     1,     1,     1,     0,     2,     1,     2,     4,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     6,     6,     3,     3,     1,     3,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     0,     3,     1,     3,     1,     1,
       1,     1,     2,     6,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     1,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 275 "./ctp_y.y" /* yacc.c:1646  */
    {
            ctltype_list *CtlType;

            CTP_HEADFIG = addctlfig( CTP_FILENAME );;
            CTP_MODNAM  = CTP_HEADFIG->NAME;
            addctlpredefinedtype( CTP_HEADFIG );

            hshtab = initab ();

            CTP_NM1LST = NULL;
            CTP_INSLST = NULL;
            CTP_LINLST = NULL;
            CTP_VALLST = NULL;

            CTP_ERRFLG    = 0;
            CTP_LINNUM    = 1;
            CTP_NUMTYP    = 0;

            CtlType = CTP_HEADFIG->TYPE;

            while( CtlType )
            {
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_LBLDFN,CtlType->CLASS);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_TYPDFN,CtlType->INDEX);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMNDFN,CtlType->LEFT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_WMXDFN,CtlType->RIGHT);
              addtab(hshtab,CtlType->NAME,CTP_MODNAM,CTP_PNTDFN,(long)CtlType);

              CtlType = CtlType->NEXT;
            }

            CTP_NUMTYP = VEX_MAX_TYPE;
          }
#line 1825 "y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 310 "./ctp_y.y" /* yacc.c:1646  */
    {
            fretab( hshtab );
          }
#line 1833 "y.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 321 "./ctp_y.y" /* yacc.c:1646  */
    {
         }
#line 1840 "y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 345 "./ctp_y.y" /* yacc.c:1646  */
    {
           my_ctp_error(9,NULL);
         }
#line 1848 "y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 358 "./ctp_y.y" /* yacc.c:1646  */
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlCst;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( (yyvsp[-3].name).NAME );

          if ( ( (yyvsp[-2].name).LEFT  == -1 ) &&
               ( (yyvsp[-2].name).RIGHT == -1 ) )
          {
            AttrLeft  = Type->LEFT;
            AttrRight = Type->RIGHT;
          }
          else
          {
            AttrLeft  = (yyvsp[-2].name).LEFT;
            AttrRight = (yyvsp[-2].name).RIGHT;
          }

          CtlCst  = (ctldecl_list *)ctp_addstr( 'C',0,val_type((yyvsp[-3].name).NAME),
                 (yyvsp[-3].name).TYPE,(yyvsp[-3].name).FLAG,(yyvsp[-5].text),AttrLeft,AttrRight,VexValue);

          Signed = ( IsVexNodeSigned( CtlCst->VEX_ATOM ) != 0 );

          {
            if ( IsVexAtomBit( CtlCst->VEX_ATOM ) )
            {
              Left  = -1;
              Right = -1;
            }
            else
            {
              Left  = CtlCst->VEX_ATOM->LEFT;
              Right = CtlCst->VEX_ATOM->RIGHT;
            }
          }

          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[-3].name).TYPE);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlCst->VEX_ATOM);
          addtab(hshtab,(yyvsp[-5].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 1911 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 423 "./ctp_y.y" /* yacc.c:1646  */
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'A',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 1954 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 468 "./ctp_y.y" /* yacc.c:1646  */
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'I',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 1997 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 513 "./ctp_y.y" /* yacc.c:1646  */
    {
          ctltype_list  *Type;
          ctldecl_list  *CtlAss;
          vexexpr       *VexValue;
          chain_list    *HeadChain;
          chain_list    *ScanChain;
          ctp_vexstr    *VexStr;
          short          Signed;
          long           Left;
          long           Right;
          short          Width;
          long           AttrLeft;
          long           AttrRight;

          VexValue = simpvexexpr( (yyvsp[-1].list).VEX );

          Type = val_type( "boolean" );

          AttrLeft  = -1;
          AttrRight = -1;

          CtlAss  = (ctldecl_list *)ctp_addstr( 'R',0, Type,
                 VEX_TYPE_BOOLEAN, 0, (yyvsp[-2].text), AttrLeft,AttrRight,VexValue);

          Signed = 0;
          Left   = -1;
          Right  = -1;

          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_TYPDFN,VEX_TYPE_BOOLEAN);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMNDFN,Left);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_WMXDFN,Right);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATLDFN,AttrLeft);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_ATRDFN,AttrRight);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_LBLDFN,0);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlAss->VEX_ATOM);
          addtab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SUNDFN,Signed );
        }
#line 2040 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 557 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2046 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 567 "./ctp_y.y" /* yacc.c:1646  */
    {
            char         *LocalName;
            char         *signame;
            char         *codedsigname;
            char          buffer[ 128 ];
            ctltype_list *Type;
            ctldecl_list *CtlVar;
            short         Signed;
            long          Left;
            long          Right;
            long          AttrLeft;
            long          AttrRight;
            char          StrFlag;
            vexexpr      *VexInit;
            struct ctp_expr expr1;

            LocalName = CTP_MODNAM;
            Type  = val_type( (yyvsp[-2].name).NAME );

            if ( ( (yyvsp[-1].name).LEFT  == -1 ) &&
                 ( (yyvsp[-1].name).RIGHT == -1 ) )
            {
              AttrLeft  = Type->LEFT;
              AttrRight = Type->RIGHT;
            }
            else
            {
              AttrLeft  = (yyvsp[-1].name).LEFT;
              AttrRight = (yyvsp[-1].name).RIGHT;
            }

            CTP_NM1LST = reverse (CTP_NM1LST);

            while (CTP_NM1LST != NULL)
            {
              signame = (char *)CTP_NM1LST->DATA;
              if (chktab (hshtab,signame,LocalName,CTP_SYMDFN) != 0)
                  my_ctp_error (80,signame);

              CtlVar = (ctldecl_list *)ctp_addstr( 'V', 0,
                      val_type((yyvsp[-2].name).NAME),(yyvsp[-2].name).TYPE,
                      (yyvsp[-2].name).FLAG,signame, AttrLeft, AttrRight, NULL );

              Signed = ( IsVexNodeSigned( CtlVar->VEX_ATOM ) != 0 );

              if ( IsVexAtomBit( CtlVar->VEX_ATOM ) )
              {
                Left  = -1;
                Right = -1;
              }
              else
              {
                Left  = CtlVar->VEX_ATOM->LEFT;
                Right = CtlVar->VEX_ATOM->RIGHT;
              }

              addtab (hshtab,signame,LocalName,CTP_SYMDFN,CTP_VARDFN);
              addtab (hshtab,signame,LocalName,CTP_TYPDFN,(yyvsp[-2].name).TYPE);
              addtab (hshtab,signame,LocalName,CTP_WMNDFN,Left);
              addtab (hshtab,signame,LocalName,CTP_WMXDFN,Right);
              addtab (hshtab,signame,LocalName,CTP_ATLDFN,AttrLeft);
              addtab (hshtab,signame,LocalName,CTP_ATRDFN,AttrRight);
              addtab (hshtab,signame,LocalName,CTP_LBLDFN,0);
              addtab (hshtab,signame,LocalName,CTP_PNTDFN,(long)CtlVar->VEX_ATOM);
              addtab (hshtab,signame,LocalName,CTP_SUNDFN,Signed);

              CTP_NM1LST = delchain (CTP_NM1LST,CTP_NM1LST);
            }
          }
#line 2120 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 649 "./ctp_y.y" /* yacc.c:1646  */
    {
           ctltype_list *CtlType;

           CtlType = addctltype( CTP_HEADFIG,(yyvsp[-3].text), CTP_NUMTYP, (yyvsp[-1].type).LEFT,
               (yyvsp[-1].type).RIGHT,(yyvsp[-1].type).SIZE,(yyvsp[-1].type).VALUE, (yyvsp[-1].type).CLASS, (yyvsp[-1].type).BASE );
           addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[-1].type).CLASS);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[-1].type).LEFT);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[-1].type).RIGHT);
           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CtlType );
           CTP_NUMTYP++;
         }
#line 2140 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 668 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 2146 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 670 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 2152 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 672 "./ctp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 2158 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 681 "./ctp_y.y" /* yacc.c:1646  */
    {
            ctltype_list *CtlType;

            CtlType = addctltype(CTP_HEADFIG,(yyvsp[-3].text),(yyvsp[-1].type).INDEX,(yyvsp[-1].type).LEFT,
                   (yyvsp[-1].type).RIGHT, (yyvsp[-1].type).SIZE, (yyvsp[-1].type).VALUE, (yyvsp[-1].type).CLASS,(yyvsp[-1].type).BASE );
            addctlline( CTP_HEADFIG, &CtlType->LINE, CTP_LINNUM);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_LBLDFN,(yyvsp[-1].type).CLASS);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_TYPDFN,(yyvsp[-1].type).INDEX);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMNDFN,(yyvsp[-1].type).LEFT);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_WMXDFN,(yyvsp[-1].type).RIGHT);
            addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE);
            CTP_NUMTYP++;
          }
#line 2177 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 701 "./ctp_y.y" /* yacc.c:1646  */
    {
           ctltype_list *ctltype_pnt;
           long          mode;
  
           mode = chktab(hshtab,(yyvsp[-2].text),CTP_MODNAM,CTP_SYMDFN);

           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).LEFT  = (yyvsp[0].name).LEFT ;
           (yyval.type).RIGHT = (yyvsp[0].name).RIGHT ;
           (yyval.type).CLASS = (yyvsp[0].name).FLAG ;
         }
#line 2199 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 720 "./ctp_y.y" /* yacc.c:1646  */
    {
           ctltype_list *ctltype_pnt;
  
           ctltype_pnt = (ctltype_list *)chktab(hshtab,(yyvsp[-1].name).NAME,CTP_MODNAM,CTP_PNTDFN);
  
           (yyval.type).NAME = NULL;
           (yyval.type).BASE = ctltype_pnt;
           (yyval.type).VALUE = NULL ;
           (yyval.type).SIZE = 0 ;
           (yyval.type).INDEX = CTP_NUMTYP;
           (yyval.type).CLASS = (yyvsp[0].name).FLAG;

           (yyval.type).LEFT    = (yyvsp[0].name).LEFT ;
           (yyval.type).RIGHT   = (yyvsp[0].name).RIGHT ;
        }
#line 2219 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 739 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 2225 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 745 "./ctp_y.y" /* yacc.c:1646  */
    {
            (yyval.type) = (yyvsp[0].type);
          }
#line 2233 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 754 "./ctp_y.y" /* yacc.c:1646  */
    {
              char *enumname;
              char *enumval;
              long  size;
              long  indice;
              long  numbit;
              char **pnt;
              chain_list *nm1lst;

              CTP_NM1LST = reverse (CTP_NM1LST);

              nm1lst = CTP_NM1LST;
              size   = 0;

              while (nm1lst != NULL)
              {
                size++;
                nm1lst = nm1lst->NEXT;
              }

              pnt = (char **) autallocblock(size * sizeof(char*));

              indice = 0;

              while (CTP_NM1LST != NULL)
              {
                enumname = (char *)CTP_NM1LST->DATA;

                if (chktab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN) != 0)
                  my_ctp_error (82,enumname);

                addtab (hshtab,enumname,CTP_MODNAM,CTP_SYMDFN,CTP_CSTDFN);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_TYPDFN,CTP_NUMTYP);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMNDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_WMXDFN,-1);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_LBLDFN,indice);
                addtab (hshtab,enumname,CTP_MODNAM,CTP_PNTDFN,(long)pnt);
                
                pnt[indice++] = enumname;
                CTP_NM1LST = delchain (CTP_NM1LST, CTP_NM1LST);
              }

              (yyval.type).VALUE = pnt ;
              (yyval.type).SIZE = size ;
              (yyval.type).LEFT = -1 ;
              (yyval.type).RIGHT = -1 ;
              (yyval.type).INDEX = CTP_NUMTYP;
              (yyval.type).CLASS = 'E' ;
              (yyval.type).BASE = 0 ;
        }
#line 2288 "y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 812 "./ctp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 2294 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 817 "./ctp_y.y" /* yacc.c:1646  */
    {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
          }
#line 2302 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 821 "./ctp_y.y" /* yacc.c:1646  */
    {
            CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
          }
#line 2310 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 828 "./ctp_y.y" /* yacc.c:1646  */
    {
            (yyval.type) = (yyvsp[0].type);
          }
#line 2318 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 835 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 2324 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 843 "./ctp_y.y" /* yacc.c:1646  */
    {
            ctltype_list *NewType;
            char       *name;
            char        buffer[ 32 ];

            (yyval.type) = (yyvsp[0].type);

            if ( (yyvsp[0].type).CLASS == 'U' )
            {
              if ( (yyvsp[0].type).BASE->CLASS != 'A' )
              {
                my_ctp_error(123,NULL);
              }
            }
            else
            if ( (yyvsp[0].type).CLASS == 'A' )
            {
              if ( (yyvsp[0].type).BASE->CLASS != 'U' )
              {
                my_ctp_error(123,NULL);
              }

              sprintf( buffer, "_subtype_%d", CTP_NUMTYP );
              name = namealloc( buffer );

              NewType = addctltype(CTP_HEADFIG,name,(yyvsp[0].type).INDEX, (yyvsp[0].type).LEFT,
                   (yyvsp[0].type).RIGHT,(yyvsp[0].type).SIZE,(yyvsp[0].type).VALUE,(yyvsp[0].type).CLASS,(yyvsp[0].type).BASE );
              addctlline( CTP_HEADFIG, &NewType->LINE, CTP_LINNUM);
              addtab(hshtab,name,CTP_MODNAM,CTP_SYMDFN,CTP_TPEDFN);
              addtab(hshtab,name,CTP_MODNAM,CTP_LBLDFN,(yyvsp[0].type).CLASS);
              addtab(hshtab,name,CTP_MODNAM,CTP_TYPDFN,(yyvsp[0].type).INDEX);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMNDFN,(yyvsp[0].type).LEFT);
              addtab(hshtab,name,CTP_MODNAM,CTP_WMXDFN,(yyvsp[0].type).RIGHT);
              addtab(hshtab,name,CTP_MODNAM,CTP_PNTDFN,(long)CTP_HEADFIG->TYPE );
              CTP_NUMTYP++;

              (yyval.type).BASE = NewType;
            }
            else
            {
              my_ctp_error(123,NULL);
            }

            (yyval.type).CLASS = 'A';
            (yyval.type).INDEX = (yyvsp[-2].name).TYPE;

            (yyval.type).LEFT  = (yyvsp[-2].name).LEFT;
            (yyval.type).RIGHT = (yyvsp[-2].name).RIGHT;
          }
#line 2378 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 898 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[-1].name);}
#line 2384 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 903 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name);}
#line 2390 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 906 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name);
           (yyval.name).NAME = (yyvsp[-1].name).NAME;
         }
#line 2398 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 911 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name);}
#line 2404 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 916 "./ctp_y.y" /* yacc.c:1646  */
    {
          (yyval.name).FLAG   = 'U';
          (yyval.name).LEFT   = -1;
          (yyval.name).RIGHT  = -1;
        }
#line 2414 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 922 "./ctp_y.y" /* yacc.c:1646  */
    { 
          (yyval.name) = (yyvsp[0].name);
        }
#line 2422 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 929 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.name) = (yyvsp[0].name);
         }
#line 2430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 936 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.name) = (yyvsp[-1].name);
         }
#line 2438 "y.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 944 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 2444 "y.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 949 "./ctp_y.y" /* yacc.c:1646  */
    {
           if ( ( (yyvsp[0].name).FLAG != CTP_RANGE     ) &&
                ( (yyvsp[0].name).FLAG != CTP_REV_RANGE ) )
           {
             my_ctp_error (32,NULL);
           }

           (yyval.name) = (yyvsp[0].name);
         }
#line 2458 "y.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 961 "./ctp_y.y" /* yacc.c:1646  */
    {
           long Left;
           long Right;
           long ErrorL;
           long  ErrorR;

           ErrorL = ctp_vextonum( (yyvsp[-2].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[0].list).VEX, &Right );

           (yyval.name).NAME   = NULL;
           (yyval.name).TYPE   = (yyvsp[-2].list).TYPE;
           (yyval.name).SIGNED = 0;
           (yyval.name).FLAG   = 'A';

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[-1].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[-1].valu) == CTP_DWTDFN)))
             {
               my_ctp_error (32,NULL);
             }

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             (yyval.name).LEFT    = (long)(yyvsp[-2].list).VEX;
             (yyval.name).RIGHT   = (long)(yyvsp[0].list).VEX;
           }
         }
#line 2494 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 996 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_UPTDFN; }
#line 2500 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 998 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_DWTDFN; }
#line 2506 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1005 "./ctp_y.y" /* yacc.c:1646  */
    {
              long type;
              (yyval.name).NAME = (yyvsp[0].text);
              (yyval.name).LEFT = -1;
              (yyval.name).RIGHT = -1;
              (yyval.name).TYPE = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_TYPDFN);
              (yyval.name).FLAG = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_LBLDFN);
              type = chktab(hshtab,(yyvsp[0].text),CTP_MODNAM,CTP_SYMDFN);

              if (type != CTP_TPEDFN || (yyval.name).TYPE ==0)
              {
                my_ctp_error(84,(yyvsp[0].text));
              }
          }
#line 2525 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1035 "./ctp_y.y" /* yacc.c:1646  */
    { my_ctp_error (18,NULL); }
#line 2531 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1043 "./ctp_y.y" /* yacc.c:1646  */
    {
           ctlform_list *CtlForm;
           vexexpr      *VexForm;

           VexForm = simpvexexpr( (yyvsp[-1].list).VEX );

           if (chktab (hshtab,(yyvsp[-3].text), CTP_MODNAM,CTP_SYMDFN) != 0)
           {
             my_ctp_error (80,(yyvsp[-3].text));
           }

           CtlForm = addctlform( CTP_HEADFIG, (yyvsp[-3].text), VexForm );
           addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM);

           addtab(hshtab,(yyvsp[-3].text),CTP_MODNAM,CTP_SYMDFN,CTP_LABDFN);
         }
#line 2552 "y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1063 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2558 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1065 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2564 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1067 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2570 "y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1069 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2576 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1076 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2584 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1082 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_AND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2592 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1091 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2600 "y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1097 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_OR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2608 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1104 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2614 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1108 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_NAND ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2622 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1114 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_NOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2630 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1120 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_NXOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2638 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1126 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_IFT,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2646 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1135 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_EU,(yyvsp[-3].list) ,(yyvsp[-1].list) ,-1,-1);
         }
#line 2654 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1144 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex (VEX_AU,(yyvsp[-3].list) ,(yyvsp[-1].list) ,-1,-1);
         }
#line 2662 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1153 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2670 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1159 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.list) = ctp_crtvex (VEX_XOR ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2678 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1166 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2684 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1170 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex ((yyvsp[-1].valu) ,(yyvsp[-2].list) ,(yyvsp[0].list) ,-1,-1);
         }
#line 2692 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1177 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2698 "y.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1182 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2704 "y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1185 "./ctp_y.y" /* yacc.c:1646  */
    {
             if ( (yyvsp[-1].valu) == VEX_NEG )
             {
               (yyval.list) = ctp_crtvex( VEX_NEG,(yyvsp[0].list),NULL,-1,-1);
             }
             else
             {
               (yyval.list) = (yyvsp[0].list);
             }
          }
#line 2719 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1198 "./ctp_y.y" /* yacc.c:1646  */
    {
            (yyval.list) = ctp_crtvex((yyvsp[-1].valu),(yyvsp[-2].list),(yyvsp[0].list),-1,-1);
          }
#line 2727 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1205 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_ADD; }
#line 2733 "y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1207 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_SUB; }
#line 2739 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1209 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_CONCAT; }
#line 2745 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1213 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = 0; }
#line 2751 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1215 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_NEG; }
#line 2757 "y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1220 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_MUL; }
#line 2763 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1222 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_DIV; }
#line 2769 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1224 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_MOD; }
#line 2775 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1226 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_REM; }
#line 2781 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1231 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 2787 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1235 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.list) = ctp_crtvex( (yyvsp[-1].valu), (yyvsp[-2].list), (yyvsp[0].list),-1,-1);
         }
#line 2795 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1242 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.list) = (yyvsp[0].list);
         }
#line 2803 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1248 "./ctp_y.y" /* yacc.c:1646  */
    {
           (yyval.list) = ctp_crtvex( VEX_EXP,(yyvsp[-2].list),(yyvsp[0].list),-1,-1);
         }
#line 2811 "y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1253 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_ABS,(yyvsp[0].list),CTP_EMPSTR,-1,-1); 
         }
#line 2819 "y.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1258 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_NOT,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2827 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1263 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_AG,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2835 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1268 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_AF,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2843 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1273 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_AX,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2851 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1278 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_EF,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2859 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1283 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_EG,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2867 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1288 "./ctp_y.y" /* yacc.c:1646  */
    { 
           (yyval.list) = ctp_crtvex( VEX_EX,(yyvsp[0].list),CTP_EMPSTR,-1,-1);
         }
#line 2875 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1295 "./ctp_y.y" /* yacc.c:1646  */
    {
           struct ctp_expr expr1;

           expr1.IDENT = (yyvsp[0].text);
           expr1.TYPE  = -1;
           expr1.VEX   = (vexexpr *)0;

           (yyval.list) = ctp_crtvex( NOPS,expr1,CTP_EMPSTR,-1,-1);
        }
#line 2889 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1305 "./ctp_y.y" /* yacc.c:1646  */
    {
            ctp_vexstr *VexStr;
            chain_list *ScanChain;

            ScanChain = (yyvsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            if ( ScanChain->NEXT == (chain_list *)0 )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              (yyval.list) = *VexStr;

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
            else
            {
              (yyval.list).IDENT  = (char *)(yyvsp[0].pcha);
              (yyval.list).AGGREG = 1;
            }
        }
#line 2920 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1332 "./ctp_y.y" /* yacc.c:1646  */
    {
          struct ctp_expr expr1;
          char           *LocalName;
          char            Buffer[ 40 ];
          long            left;
          long            right;
          long            left_bnd;
          long            right_bnd;
          long            in_bound;
          long            out_bound;
          long             mode;
          long             flag;

          flag = (yyvsp[0].name).FLAG;

          if ( ( flag != 0          ) &&
               ( flag != CTP_EVENT  ) &&
               ( flag != CTP_STABLE ) )
          {
            if ( ( flag != CTP_RANGE     ) &&
                 ( flag != CTP_REV_RANGE ) )
            {
              {
                sprintf( Buffer, "%ld", (yyvsp[0].name).LEFT );

                expr1.IDENT = Buffer;
                expr1.VEX   = (vexexpr *)0;
                expr1.TYPE  = -1;

                (yyval.list) = ctp_crtvex( NOPS, expr1, CTP_EMPSTR, -1, -1);
              }
            }
            else
            {
              autexit( 1 );
            }
          }
          else
          if ( ( (yyvsp[0].name).NAME[0] == '"' ) ||
               ( (yyvsp[0].name).NAME[0] == '\'') )
          {
            expr1.IDENT = (yyvsp[0].name).NAME;
            expr1.VEX   = (vexexpr *)0;
            expr1.TYPE  = -1;

            (yyval.list) = ctp_crtvex( NOPS ,expr1, CTP_EMPSTR, -1, -1); /* as for literal */
          }
          else
          {
            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_SYMDFN);

            if( mode == 0 )
            {
              my_ctp_error (17,(yyvsp[0].name).NAME);
            }

            left_bnd  = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_WMNDFN);
            right_bnd = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_WMXDFN);
              
            left  = (yyvsp[0].name).LEFT;
            right = (yyvsp[0].name).RIGHT;

            {
              long  type;

              expr1.IDENT = (yyvsp[0].name).NAME;
              type = chktab(hshtab,(yyvsp[0].name).NAME,LocalName,CTP_TYPDFN);
              expr1.TYPE = type;
              expr1.SIGNED = chktab (hshtab,(yyvsp[0].name).NAME,LocalName,CTP_SUNDFN);

              {
                expr1 = ctp_crtvex (NOPI,expr1,CTP_EMPSTR,left,right);
              }

              if( flag == CTP_EVENT )
              {
                (yyval.list) = ctp_crtvex (VEX_EVENT,expr1,CTP_EMPSTR,left,right);
              }
              else
              if( flag == CTP_STABLE )
              {
                expr1 = ctp_crtvex(VEX_EVENT,expr1,CTP_EMPSTR,left,right);
                (yyval.list)    = ctp_crtvex (VEX_NOT,expr1,CTP_EMPSTR,-1,-1);
              }
              else
              {
                (yyval.list) = expr1;
              }
            }
          }
        }
#line 3017 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1425 "./ctp_y.y" /* yacc.c:1646  */
    {
          struct ctp_expr expr1;

          expr1.IDENT  = (yyvsp[0].name).NAME;
          expr1.TYPE   = (yyvsp[0].name).TYPE;
          expr1.SIGNED = (yyvsp[0].name).SIGNED;
          expr1.VEX    = (vexexpr *)(yyvsp[0].name).LEFT;

          expr1 = ctp_crtvex(SUBVAR,expr1,CTP_EMPSTR,expr1.VEX->LEFT,expr1.VEX->RIGHT);

          (yyval.list) = expr1;
        }
#line 3034 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1443 "./ctp_y.y" /* yacc.c:1646  */
    {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            long        Def;

            ScanChain = (yyvsp[0].pcha);

            if ( ( ScanChain       == (chain_list *)0 ) ||
                 ( ScanChain->NEXT != (chain_list *)0 ) )
            {
              my_ctp_error(122,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SYMDFN);

            if ( Def == CTP_TPEDFN )
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;

              VexExpr = createvexfunc( (yyvsp[-2].name).NAME, VexStr->VEX->WIDTH );
              addvexhexpr( VexExpr, VexStr->VEX );

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              (yyval.name).NAME    = (yyvsp[-2].name).NAME;
              (yyval.name).TYPE    = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED  = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SUNDFN);
              (yyval.name).FLAG    = 0;
              (yyval.name).LEFT    = (long)VexExpr;
              (yyval.name).RIGHT   = 0;

              freechain( (yyvsp[0].pcha) );
            }
            else
            {
              my_ctp_error(122, (yyvsp[-2].name).NAME);
            }
          }
#line 3080 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1488 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_EQ; }
#line 3086 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1490 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_NE; }
#line 3092 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1492 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_GE; }
#line 3098 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1494 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_GT; }
#line 3104 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1496 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_LE; }
#line 3110 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1498 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_LT; }
#line 3116 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1500 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_EQUIV; }
#line 3122 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1502 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = VEX_IMPLY; }
#line 3128 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1507 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3134 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1509 "./ctp_y.y" /* yacc.c:1646  */
    { 
                (yyval.text) = (yyvsp[0].text); }
#line 3141 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1512 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3147 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1514 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1516 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = namealloc( "'1'" ); }
#line 3159 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1518 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = namealloc( "'0'" ); }
#line 3165 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1526 "./ctp_y.y" /* yacc.c:1646  */
    {
            if ( (yyvsp[-1].pcha) != (chain_list *)0 )
            {
              (yyvsp[-2].pcha)->NEXT = reverse( (yyvsp[-1].pcha) );
            }

            (yyval.pcha) = (yyvsp[-2].pcha);
          }
#line 3178 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1538 "./ctp_y.y" /* yacc.c:1646  */
    { 
            (yyval.pcha) = (chain_list *)0;
          }
#line 3186 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1544 "./ctp_y.y" /* yacc.c:1646  */
    {
            if ( (yyvsp[-2].pcha) != (chain_list *)0 )
            {
              (yyvsp[0].pcha)->NEXT = (yyvsp[-2].pcha);
            }

            (yyval.pcha) = (yyvsp[0].pcha);
          }
#line 3199 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1556 "./ctp_y.y" /* yacc.c:1646  */
    { 
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = (yyvsp[0].list);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3212 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1567 "./ctp_y.y" /* yacc.c:1646  */
    {
            ctp_vexstr *VexStr;

            VexStr  = (ctp_vexstr *)autallocheap( sizeof( ctp_vexstr ) );
            *VexStr = ctp_crtvex( VEX_OTHERS, (yyvsp[0].list),CTP_EMPSTR,-1,-1);

            (yyval.pcha) = addchain( (chain_list *)0, VexStr );
          }
#line 3225 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1579 "./ctp_y.y" /* yacc.c:1646  */
    {
           authelem *valbitstr;
           char     *codedsigname;
           char     *LocalName;
           char      buffer[128];

           LocalName = CTP_MODNAM;

           (yyval.name).NAME = (yyvsp[0].text);
           (yyval.name).FLAG = 0;

           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_TYPDFN);
           (yyval.name).LEFT   = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_WMNDFN);
           (yyval.name).RIGHT  = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_WMXDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[0].text),LocalName,CTP_SUNDFN);
         }
#line 3246 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1596 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 3252 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1598 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 3258 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1600 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 3264 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1606 "./ctp_y.y" /* yacc.c:1646  */
    {
            char       *LocalName;
            ctp_vexstr *VexStr;
            chain_list *ScanChain;
            vexexpr    *VexExpr;
            vexexpr    *VexRet;
            long        Index;
            long         Error;
            long        Def;

            ScanChain = (yyvsp[0].pcha);

            if ( ScanChain == (chain_list *)0 )
            {
              my_ctp_error(114,NULL);
            }

            LocalName = CTP_MODNAM;
            Def = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SYMDFN);

            if ( ScanChain->NEXT != (chain_list *)0 )
            {
              if ( ( ! Def                                    ) || 
                   ( ScanChain->NEXT->NEXT != (chain_list *)0 ) )
              {
                my_ctp_error(118,(yyvsp[-1].text));
              }

              /* ICI */

              (yyval.name).NAME   = (yyvsp[-1].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              VexStr  = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).LEFT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              ScanChain = ScanChain->NEXT;
              VexStr   = (ctp_vexstr *)ScanChain->DATA;
              (yyval.name).RIGHT = (long)VexStr->VEX;
              autfreeheap( VexStr, sizeof( ctp_vexstr ) );

              freechain( (yyvsp[0].pcha) );
            }
            else
            {
              VexStr = (ctp_vexstr *)ScanChain->DATA;
              Error  = ctp_vextonum( VexStr->VEX, &Index );

              (yyval.name).NAME   = (yyvsp[-1].text);
              (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_TYPDFN);
              (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-1].text),LocalName,CTP_SUNDFN);
              (yyval.name).FLAG   = 0;

              if ( Error )
              {
                my_ctp_error(36, (yyvsp[-1].text));
              }
              else
              {
                (yyval.name).LEFT   = Index;
                (yyval.name).RIGHT  = Index;
              }

              autfreeheap( VexStr, sizeof( ctp_vexstr ) );
              freechain( ScanChain );
            }
          }
#line 3339 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1685 "./ctp_y.y" /* yacc.c:1646  */
    {
           char *LocalName;
           long  Left;
           long  Right;
           long   ErrorL;
           long   ErrorR;

           LocalName = CTP_MODNAM;

           ErrorL = ctp_vextonum( (yyvsp[-3].list).VEX, &Left  );
           ErrorR = ctp_vextonum( (yyvsp[-1].list).VEX, &Right );

           (yyval.name).NAME   = (yyvsp[-5].text);
           (yyval.name).TYPE   = chktab (hshtab,(yyvsp[-5].text),LocalName,CTP_TYPDFN);
           (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-5].text),LocalName,CTP_SUNDFN);
           (yyval.name).FLAG   = 0;

           if ( ( ! ErrorL ) && ( ! ErrorR ) )
           {
             if (((Left > Right) && ((yyvsp[-2].valu) == CTP_UPTDFN)) ||
                  ((Left < Right) && ((yyvsp[-2].valu) == CTP_DWTDFN)))
               my_ctp_error (32,(yyvsp[-5].text));

             (yyval.name).LEFT   = Left;
             (yyval.name).RIGHT  = Right;
           }
           else
           {
             my_ctp_error (36,(yyvsp[-5].text));
           }
         }
#line 3375 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1722 "./ctp_y.y" /* yacc.c:1646  */
    {
            char *LocalName;
            long   type;
            long   flag;
            long   mode;
            long  AttrLeft;
            long  AttrRight;
            long  AttrLow;
            long  AttrHigh;

            LocalName = CTP_MODNAM;
            mode = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SYMDFN);
            type = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_TYPDFN);
            flag = (yyvsp[0].valu);

            (yyval.name).NAME   = (yyvsp[-2].name).NAME;
            (yyval.name).TYPE   = type;
            (yyval.name).LEFT   = -1;
            (yyval.name).RIGHT  = -1;
            (yyval.name).SIGNED = chktab (hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_SUNDFN);
            (yyval.name).FLAG   = (yyvsp[0].valu);

            if ( ( flag == CTP_STABLE ) ||
                 ( flag == CTP_EVENT  ) )
            {
              if ( LocalName != CTP_MODNAM )
                my_ctp_error (79,(yyvsp[-2].name));
            }
            else
            {
              AttrLeft  = chktab( hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_ATLDFN);
              AttrRight = chktab( hshtab,(yyvsp[-2].name).NAME,LocalName,CTP_ATRDFN);

              {
                if ( AttrLeft > AttrRight )
                {
                  AttrLow  = AttrRight;
                  AttrHigh = AttrLeft;
                }
                else
                {
                  AttrHigh = AttrRight;
                  AttrLow  = AttrLeft;
                }
              }

              switch ( flag )
              {
                case CTP_LEFT   : (yyval.name).LEFT = AttrLeft;
                break;

                case CTP_RIGHT  : (yyval.name).LEFT = AttrRight;
                break;

                case CTP_LOW    : (yyval.name).LEFT = AttrLow;
                break;

                case CTP_HIGH   : (yyval.name).LEFT = AttrHigh;
                break;

                case CTP_LENGTH : (yyval.name).LEFT = 1 + (AttrHigh - AttrLow);
                break;

                case CTP_RANGE  : (yyval.name).LEFT  = AttrLeft;
                                  (yyval.name).RIGHT = AttrRight;
                break;

                case CTP_REV_RANGE : (yyval.name).LEFT  = AttrRight;
                                     (yyval.name).RIGHT = AttrLeft;
                break;
              }
            }
          }
#line 3453 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1798 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_STABLE; }
#line 3459 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1799 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_EVENT; }
#line 3465 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1800 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_LEFT; }
#line 3471 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1801 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_RIGHT; }
#line 3477 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1802 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_LOW; }
#line 3483 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1803 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_HIGH; }
#line 3489 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1804 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_LENGTH; }
#line 3495 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1805 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_RANGE; }
#line 3501 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1806 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = CTP_REV_RANGE; }
#line 3507 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1811 "./ctp_y.y" /* yacc.c:1646  */
    { CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text)); }
#line 3513 "y.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1820 "./ctp_y.y" /* yacc.c:1646  */
    { 
                  CTP_NM1LST = addchain (CTP_NM1LST,(yyvsp[0].text));
                }
#line 3521 "y.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1827 "./ctp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3527 "y.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1832 "./ctp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3533 "y.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1837 "./ctp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3539 "y.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1842 "./ctp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3545 "y.tab.c" /* yacc.c:1646  */
    break;


#line 3549 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1845 "./ctp_y.y" /* yacc.c:1906  */


static struct dct_entry *addent (head , key)
struct dct_entry *head;
char             *key;

{
  struct dct_entry *entry = NULL;
  long              i;

  if (CTP_DCEHED == NULL)
    {
    CTP_DCEHED = (struct dct_entry *)
                 autallocblock (sizeof(struct dct_entry) * CTP_ALODFN);

    entry = CTP_DCEHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = CTP_DCEHED;
  CTP_DCEHED  = CTP_DCEHED->next;

  entry->next = head;
  entry->data = NULL;
  entry->key  = key;

  return (entry);
}

static struct dct_recrd *addrcd (head , key)

struct dct_recrd *head;
char             *key;

{
  struct dct_recrd *recrd = NULL;
  long               i;

  if (CTP_DCRHED == NULL)
    {
    CTP_DCRHED = (struct dct_recrd *)
                 autallocblock (sizeof(struct dct_recrd) * CTP_ALODFN);

    recrd = CTP_DCRHED;
    for (i=1 ; i<CTP_ALODFN ; i++)
      {
      recrd->next = recrd + 1;
      recrd++;
      }
    recrd->next = NULL;
    }

  recrd           = CTP_DCRHED;
  CTP_DCRHED      = CTP_DCRHED->next;

  recrd->next     = head;
  recrd->key      = key;

  return (recrd);
}

static struct dct_entry **initab ()

{
  struct dct_entry **head = NULL;
  long                i;

  head = (struct dct_entry **)
         autallocblock (sizeof(struct dct_entry *) * CTP_HSZDFN);

  for (i=0 ; i<CTP_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
}

static void addtab (head,key_str,ctx_str,field,valu)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;
long               valu;

{
  long              found = 0;
  long              index;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  index     = ((unsigned long) key_str) % CTP_HSZDFN;
  entry_pnt = head[index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head[index] = addent (head[index],key_str);
    entry_pnt = head[index];
    }

  found = 0;
  recrd_pnt = entry_pnt->data;
  while (recrd_pnt != NULL)
    {
    if (recrd_pnt->key == ctx_str)
      {
      found = 1;
      break;
      }
    recrd_pnt = recrd_pnt->next;
    }

  if (found == 0)
    {
    entry_pnt->data = addrcd (entry_pnt->data,ctx_str);
    recrd_pnt       = entry_pnt->data ;
    }

  switch (field)
    {
      case CTP_MODDFN :
        recrd_pnt->fd0_val = valu;
        break;
      case CTP_SYMDFN :
        recrd_pnt->fd1_val = valu;
        break;
      case CTP_TYPDFN :
        recrd_pnt->fd2_val = valu;
        break;
      case CTP_SUNDFN :
        recrd_pnt->fd3_val = valu;
        break;
      case CTP_LBLDFN :
        recrd_pnt->fd4_val = valu;
        break;
      case CTP_WMXDFN :
        recrd_pnt->fd5_val = valu;
        break;
      case CTP_WMNDFN :
        recrd_pnt->fd6_val = valu;
        break;
      case CTP_ATLDFN :
        recrd_pnt->fd7_val = valu;
        break;
      case CTP_ATRDFN :
        recrd_pnt->fd8_val = valu;
        break;
      case CTP_PNTDFN :
        recrd_pnt->pnt_val = valu;
        break;
    }
}

static long chktab (head,key_str,ctx_str,field)

struct dct_entry **head;
char              *key_str;
char              *ctx_str;
long               field;

{
  long              found = 0;
  long              valu = 0;
  struct dct_entry *entry_pnt;
  struct dct_recrd *recrd_pnt;

  entry_pnt = head [((unsigned long)key_str) % CTP_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    found = 0;
    recrd_pnt = entry_pnt->data;
    while (recrd_pnt != NULL)
      {
      if (recrd_pnt->key == ctx_str)
        {
        found = 1;
        break;
        }
      recrd_pnt = recrd_pnt->next;
      }
    if (found == 1)
      {
      switch (field)
        {
        case CTP_MODDFN :
          valu = recrd_pnt->fd0_val;
          break;
        case CTP_SYMDFN :
          valu = recrd_pnt->fd1_val;
          break;
        case CTP_TYPDFN :
          valu = recrd_pnt->fd2_val;
          break;
        case CTP_SUNDFN :
          valu = recrd_pnt->fd3_val;
          break;
        case CTP_LBLDFN :
          valu = recrd_pnt->fd4_val;
          break;
        case CTP_WMXDFN :
          valu = recrd_pnt->fd5_val;
          break;
        case CTP_WMNDFN :
          valu = recrd_pnt->fd6_val;
          break;
        case CTP_ATLDFN :
          valu = recrd_pnt->fd7_val;
          break;
        case CTP_ATRDFN :
          valu = recrd_pnt->fd8_val;
          break;
        case CTP_PNTDFN :
          valu = recrd_pnt->pnt_val;
          break;
        }
      }
    }

  return (valu);
}

static void fretab (pt_hash)

struct dct_entry **pt_hash;
{
  struct dct_entry *pt_entry;
  struct dct_entry *pt_nxtentry;
  struct dct_recrd *pt_record;
  long              i;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<CTP_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry != NULL)
          {
          pt_record = pt_entry->data;

          while (pt_record->next != NULL)
            pt_record = pt_record->next;

          pt_record->next = CTP_DCRHED;
          CTP_DCRHED      = pt_entry->data;

          pt_nxtentry     = pt_entry->next;
          pt_entry->next  = CTP_DCEHED;
          CTP_DCEHED      = pt_entry;
          pt_entry        = pt_nxtentry;
          }
        }
      }
    autfreeblock(pt_hash);
    }
}

static void *ctp_addstr(object,mode,prtype,type,flag,name,left,right,exp)

char          object;
long           mode;
ctltype_list *prtype;
unsigned char type;
char          flag;
char         *name;
long          left;
long          right;
vexexpr      *exp;

{ 
  ctlform_list *CtlForm;
  ctldecl_list *CtlDeclar;
  void         *pnt    = NULL;
  vexexpr      *vex_pnt;
  long           bitsize;

  if ( object == 'F' )
  {
    CtlForm = addctlform( CTP_HEADFIG, name, exp );
    addctlline( CTP_HEADFIG, &CtlForm->LINE, CTP_LINNUM );

    return( (void *)CtlForm );
  }


  if ( (flag == 'A') ||
       (flag == 'U') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an array ...                                   */
       /* ###------------------------------------------------------### */

    if ( flag == 'A' )
    {
      vex_pnt = createvexatomvec( name, prtype->LEFT, prtype->RIGHT ); 
    }
    else
    {
      vex_pnt = createvexatomvec( name, left, right );
    }

    if ( prtype->INDEX == VEX_TYPE_SIGNED )
    {
      SetVexNodeSigned( vex_pnt );
    }

  }
  else
  if ( (flag == 'I') )
  {
       /* ###------------------------------------------------------### */
       /*   if object is an integer ...                            */
       /* ###------------------------------------------------------### */

      if ((left == -1 ) && (right == -1))
      {
        left  = prtype->LEFT;
        right = prtype->RIGHT;
      }

      bitsize = ctp_intSize( left, right );

      vex_pnt = createvexatomvec( name, bitsize - 1, 0 );

      if ( ( left  < 0 ) ||
           ( right < 0 ) )
      {
        SetVexNodeSigned( vex_pnt );
      }
  }
  else
  {
       /* ###------------------------------------------------------### */
       /*   if object is a scalar ...                                   */
       /* ###------------------------------------------------------### */
    vex_pnt = createvexatombit( name );
  }

  if ( object == 'C' )
  {
    CtlDeclar = addctldecldef( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'V' )
  {
    CtlDeclar = addctldeclvar( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'A' )
  {
    CtlDeclar = addctldeclass( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'I' )
  {
    CtlDeclar = addctldeclinit( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }
  else
  if ( object == 'R' )
  {
    CtlDeclar = addctldeclreset( CTP_HEADFIG, vex_pnt );
    CtlDeclar->TYPE     = prtype;
    CtlDeclar->VEX_INIT = exp;
    addctlline( CTP_HEADFIG, &CtlDeclar->LINE, CTP_LINNUM );

    pnt = (void *)CtlDeclar;
  }

  return (pnt);
}

static ctltype_list *val_type(name)

 char *name;
{
  return( searchctltype( CTP_HEADFIG, name ) );
}

static ctltype_list *get_type(val)

  long val;
{
  ctltype_list *Type;

  for ( Type  = CTP_HEADFIG->TYPE;
        Type != (ctltype_list *)0;
        Type  = Type->NEXT )
  {
    if  ( Type->INDEX == val ) break;
  }

  return( Type );
}

int ctp_y_wrap ()
{
  return (1);
}

